
// --------------------------------------------------- Include ;)
// per ioctl ;)
#include <sys/ioctl.h>

// per la socket
#include <sys/socket.h>

// per la select
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

// per i vari protocolli di rete ;)
//#include <linux/in.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

// per la perror
#include <stdio.h>

//per il bcopy
#include <string.h>

//per la atoi
#include <stdlib.h>

// --------------------------------------------------- Definizioni ;)
#define KDGETLED        0x4B31  /* return current led state */
#define KDSETLED        0x4B32  /* set led state [lights, not flags] */
#define         LED_SCR         0x01    /* scroll lock led */
#define         LED_CAP         0x04    /* caps lock led */
#define         LED_NUM         0x02    /* num lock led */

#define SI 0x01

#define VERSIONE "___ipLOGled___v.0.0.1__________Whoix_Dump_____________"


struct tcpheader {
	struct ip ip;
	struct tcphdr tcp;
};
struct icmpheader
{
	struct ip ip;
	struct icmphdr icmp;
};
struct udpheader
{
	struct ip ip;
	struct udphdr udp;
};


// --------------------------------------------------- Funzioni ;)
void LedsOFF(void)
{
	ioctl(0, KDSETLED, 0);
}

void LedScrON(void)
{
	ioctl(0, KDSETLED,LED_SCR);
}
void LedNumON(void)
{
	ioctl(0, KDSETLED,LED_NUM);
}
void LedCapON(void)
{
	ioctl(0, KDSETLED,LED_CAP);
}

int CreaRAWSocket(int Tipo)
{
	int S;
	
	S=socket( AF_INET , SOCK_RAW , Tipo);
	if (S<0)
	{
		perror("Socket NOT Created ");
		exit (-999);
	}
	return S;
}

void StampaVersione(void)
{
	printf("\n%s\n\n",VERSIONE);
}
void AiutoUso(char * NomeProgramma)
{
	StampaVersione();
	printf("\t%s [OPTIONS]\n\n", NomeProgramma);
	printf("options should be :\n");
	printf("-v : print the version and exit\n");
	printf("-h : print this help\n");
	printf("ONLY for the TCP packets:\n");
	printf("-s : (default) Check only the packet with SYN (new connection)\n");
	printf("-t number : check only the numberTH packet\n");
	/*
	printf("ONLY for the UDP packets:\n");
	printf("-u number : check only the numberTH packets\n");
	printf("ONLY for the ICMP packets:\n");
	printf("-i number : check only the numberTH packets\n");
	*/

}

int  main(int argc , char ** argv)
{
	fd_set LogFD;
	fd_set OrigFD;
	
	int ICMPfd;
	//long NumICMP=0;
	int UDPfd;
	//long ContaUDP=0;
	int TCPfd;
	long ContaTCP=0;
	int retVal;
	struct tcpheader  TCPHeader;
	struct icmpheader ICMPHeader;
	struct udpheader  UDPHeader;
	
	int opt;
	int CheckSYN=0;
	//0 controlla solo i syn altrimenti ogni CheckSYN pacchetti

	while ( (opt = getopt(argc, argv, "st:vh")) != EOF)
	{
		switch(opt)
		{
			case 's':
				CheckSYN=0;
				break;
			case 't':
				CheckSYN= atoi(optarg);
				break;
			case 'v':
				StampaVersione();
				exit(0);
				break;
			case 'h':
				AiutoUso(argv[0]);
				exit(0);
				break;
			default:
				fprintf(stderr, "SYNtax ERRor in ur command !");
				AiutoUso(argv[0]);
				exit(-999);
				break;
		}
	}

	ICMPfd = CreaRAWSocket(IPPROTO_ICMP);
	UDPfd  = CreaRAWSocket(IPPROTO_UDP);
	TCPfd  = CreaRAWSocket(IPPROTO_TCP);

	FD_ZERO(&OrigFD);
	FD_ZERO(&LogFD);

	FD_SET ( ICMPfd , &OrigFD);
	FD_SET ( UDPfd  , &OrigFD);
	FD_SET ( TCPfd  , &OrigFD);
	
	
	while(1)
	{
		//bcopy( (char *) &OrigFD, (char *) &LogFD,sizeof(LogFD));
		FD_SET ( ICMPfd , &LogFD);
		FD_SET ( UDPfd  , &LogFD);
		FD_SET ( TCPfd  , &LogFD);
		
		retVal= select (10, &LogFD,(fd_set*)0,(fd_set*)0,(struct
					timeval *) 0);
		if (retVal <0)
		{
			perror("Select Error ");
			exit (-999);
		}

		if (FD_ISSET(ICMPfd,&LogFD) )
		{
			LedNumON();
			read(ICMPfd, (struct icmpheader *)&ICMPHeader,
					sizeof(ICMPHeader));
			LedsOFF();
		}
		if ( FD_ISSET(UDPfd,&LogFD) )
		{
			LedCapON();
			read(UDPfd, (struct udpheader
						*)&UDPHeader,sizeof(UDPHeader));
			LedsOFF();
		}
		if ( FD_ISSET(TCPfd,&LogFD) )
		{
			read(TCPfd, (struct tcpheader
						*)&TCPHeader,sizeof(TCPHeader));
			if (CheckSYN==0)
			{
				if (TCPHeader.tcp.syn == SI)
				{
					LedScrON();
					LedsOFF();
				}
			}
			else
			{
				ContaTCP++;
				if (ContaTCP==CheckSYN)
				{
				
					LedScrON();
					LedsOFF();
					ContaTCP=0;
				}
			}
			
		}
		
		
	}
	exit(0);

}
